/**
 * Discussion Tab
 */

var Discussion = {
		type: 'Discussion',
		GetScreen: function(tab){
			var div=$('#'+tab.tabType+'-'+tab.tabId);
			
			var responseForm = $('<div></div>').css({ 'margin-left': '20px', 'margin-right': '20px' });
			var textHeight = Math.min(150, GS.screenY/3);
			responseForm
			.append(
					$('<p>Ask your question:</p>')
			)
			.append(
					$('<textarea/>')
						.attr('id', 'question-txt-' + tab.tabId)
						.css({ width: (GS.screenX - 100) + 'px' , height: textHeight + 'px' })
			)
			.append(
					$('<button>Send</button>')
					.addClass('btn-fix')
					.addClass('ui-btn')
					.addClass('ui-btn-corner-all')
					.addClass('ui-shadow')
					.addClass('ui-btn-up-d')
					.addClass('send-question-btn')
					.css({ width: '100px !important' })
					.data('tab', tab)
					.bind( "click", function(event, ui) {
						if(GS.user == null){
							alert("Please login or signup for add question.");
						}
						else{
							var text = $('#question-txt-' + $(this).data('tab').tabId).val();
							Discussion.AddQuestion(GS.user.id, text, app.appId, tab);
							$('#question-txt-' + $(this).data('tab').tabId).val('');
						}
					})
			);
			div.append(responseForm);
			
			$("#question-list-" + tab.tabId).remove();
			var ul = $('<ul data-role="listview" data-inset="true" data-theme="d"></ul>')
						.css({ 'margin': '0 0 0 0' })
						.attr('id', 'question-list-' + tab.tabId);
			div.append(ul);
			var appGuid = app.appId; //for test: 'CF60D269-B917-4024-ADB3-DAAB82CEF5F5';
			Discussion.getQuestions(appGuid, 0, div, tab);
			var buttonMore = $('<a href="#" data-role="button" data-inline="true">More</a>')
								.data('start', 0)
								.data('tab', tab)
								.data('divId', tab.tabType + '-' + tab.tabId)
								.attr('id', 'question-more-' + tab.tabId)
								.css({ width: '100px', 'margin-left': '20px' })
								.click(function(){
									Discussion.getQuestions(appGuid, $(this).data('start'), div, tab);
								});
			div.append(buttonMore);
		},
		onOpen: function(tab){
			var div = $("#" + tab.tabType + '-' + tab.tabId);
			$("#" + tab.tabType + '-' + tab.tabId).find('.ui-page').css({ display: 'block', position: 'relative' });
			var btn = div.find('.send-question-btn')[0];
			if($(btn).parent().hasClass('ui-btn') == true){
				$(btn).parent().css({ width: '100px' });
			}
		},
		getQuestions: function(appGuid, start, div, tab){
			$.mobile.showPageLoadingMsg();
			var url = GS.processorUrl + '/RequestProcessor.ashx?cmd=getQuestions&appId='+appGuid+'&start='+start;
			$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			var xml = unescape(proxy_resp.content);
			    			if(xml == 'Web error'){
			    				var message = 'Server side error';
			    				alert(message);
			    			}
			    			else{
			    				var xmlDocL = $.parseXML(xml);
			    				var questions = $(xmlDocL).find('question');
			    				var total = $(xmlDocL).find('total')[0].textContent;
			    				var ul = $('#question-list-' + tab.tabId);
			    				for(var i = 0; i < questions.length; i++){
			    					var question = new Object();
			    					question["id"] = $(questions[i]).find('id')[1].textContent;
			    					question["date"] = $(questions[i]).find('date')[0].textContent;
			    					question["text"] = $(questions[i]).find('text')[0].textContent;
			    					question["responseTotal"] = $(questions[i]).find('responseTotal')[0].textContent;
			    					var user = new Object();
			    					user["id"] = $(questions[i]).find('id')[0].textContent;
			    					user["email"] = $(questions[i]).find('email')[0].textContent;
			    					user["name"] = $(questions[i]).find('name')[0].textContent;
			    					user["locationName"] = $(questions[i]).find('locationName')[0].textContent;
			    					question["user"] = user;
			    					ul.append(Discussion.DrawQuestionItem(question, tab, start * 10 + i));
			    				}
			    				$('#question-more-' + tab.tabId).data('start', start + 1);
			    				div.css({ height: ((start + 1) * 10 * 150) + 'px' });
			    				
			    				if(total == 0){
			    					$('#question-more-' + tab.tabId).css({ display: 'none' });
			    				}
			    				
			    				//div.append(ul);
			    			}
			    			proxy_resp = null;
			    			$.mobile.hidePageLoadingMsg();
			    		}
			    		else{
			    			$.mobile.hidePageLoadingMsg();
			    		}
		    		});
		},
		DrawQuestionItem: function(item, tab, number){
			var itemDiv = $('<div></div>')
							.append(
								$('<font>' + item.user.name + ' asked: </font>')
									.css({
										'font-size':'14px'
									})
							)
							.append('<br/>')
							.append(
								$('<font>Responses: ' + item.responseTotal + '</font>')
									.css({
											'font-size':'12px'
									})
							)
							.append('<br/><br/>')
							.append(
									$('<font>' +item.text + '</font>')
							)
							.css({ 'margin': '5px 5px 5px 20px' });
			var li = $('<li></li>')
						.data('item', item)
						.data('tabType', tab.tabType)
						.data('tabId', tab.tabId)
						.data('num', number)
						.data('itemId', tab.tabId+'-'+number)
						.attr('data-theme', 'c')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.addClass('item-question')
						.css({width:'100%', 'border-collapse': 'collapse'})
						.append(
								itemDiv
						)
						.click(function(){
							 $("#question-screen-"+$(this).data('itemId')).find('ul').listview();
							 $("#question-screen-"+$(this).data('itemId')).css({display:'block'});
							 ScrollUp($(this).data('tabType') + '-' + $(this).data('tabId'));
							 ScrollUp("question-screen-"+$(this).data('itemId'));
							 $("#" + $(this).data('tabType') + '-' + $(this).data('tabId')).css({height: '1000px'});
								GS.showBackBtn();
								BackStack.down({ screenId: "question-screen-"+$(this).data('itemId') });
								/*GS.BackBtn
								//.unbind()
								.data('screenid', "question-screen-"+$(this).data('itemId'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								});*/
								return false;
						});
			$("#question-screen-" + tab.tabId + "-" + number).remove();
			var screen = $('<div></div>')
				.attr('id', 'question-screen-' + tab.tabId + '-' + number)
				.css({display:'none', top: '0', 'background-color': '#e0e0e0', color: '#202020'})
				.addClass('child-screen');
			screen.append(Discussion.GetQuestionScreen(item, tab))
			$("#"+ tab.tabType+'-'+tab.tabId).append(screen);
			
			return li;
		},
		GetQuestionScreen: function(question, tab){
			var div = $('<div></div>');
			var questionText = $('<p>On ' + question.date + ', ' 
										  + question.user.name + ' (' + question.user.email + ') asked:<br/>' 
										  + '<b>'+ question.text + '</b></p>')
								.css({
									'font-size': '16px',
									'margin-left': '20px',
									'margin-right': '20px'
								});
			var askText = $('<p>Add your response:</p>').css({ 'margin-left': '20px', 'margin-right': '20px' });
			var responseForm = $('<div></div>').css({ 'margin-left': '20px', 'margin-right': '20px' });
			var textHeight = Math.min(150, GS.screenY/3);
			responseForm.append(
					$('<textarea/>')
						.attr('id', 'response-txt-' + tab.tabId)
						.css({ width: '100%', height: textHeight + 'px' })
						.addClass('ui-input-text') 
						.addClass('ui-body-null')
						.addClass('ui-corner-all') 
						.addClass('ui-shadow-inset') 
						.addClass('ui-body-c')
			)
			.append(
					$('<button data-role="button">Send</button>')
					.addClass('btn-fix')
					.addClass('ui-btn')
					.addClass('ui-btn-corner-all')
					.addClass('ui-shadow')
					.addClass('ui-btn-up-d')
					.css({ width: '100px', 'font-size': '16px', 'height': '30px' })
					.data('question', question)
					.data('tab', tab)
					.bind( "click", function(event, ui) {
						if(GS.user == null){
							alert("Please login or signup for add response.");
						}
						else {
							var text = $("#response-txt-" + $(this).data('tab').tabId).val();
							Discussion.AddResponse(GS.user.id, question.id, text);
							var text = $("#response-txt-" + $(this).data('tab').tabId).val('');
						}
					})
			);
			div
				.append(questionText)
				.append(askText)
				.append(responseForm);
			var url = GS.processorUrl + "/RequestProcessor.ashx?cmd=getResponses&questionId=" + question.id;
			$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			var xml = unescape(proxy_resp.content);
			    			if(xml == 'Web error'){
			    				var message = 'Server side error';
			    				alert(message);
			    			}
			    			else{
			    				var xmlDoc = $.parseXML(xml);
			    				var community = $(xmlDoc).find('community')[0];
			    				var facebook = $(xmlDoc).find('facebook')[0];
			    				var count = new Object();
			    				count["community"] = $(community).find('total')[0].textContent;
			    				count["facebook"] = $(facebook).find('total')[0].textContent;
			    				
			    				var countInfo = $("<p>Comments from community: " + count.community + "<br>Comments from Facebook: " + count.facebook + "</p>")
			    									.css({'margin-left': '20px',
			    										  'margin-right': '20px'});
			    				div.append(countInfo);
			    				
			    				var responses = $(xmlDoc).find('response');
			    				var listId = 'responses-list' + question.id;
								$("#"+listId).remove();
								var resultList = $('<ul data-role="listview" data-inset="true" data-theme="d"></ul>')
													.attr('id', listId);
								//screen.css({ height: (50*stores.length)+'px' });
								//screen.parent().css({ height: (50*stores.length+20)+'px' });
			    				for(var i = 0; i < responses.length; i++){
			    					var response = new Object();
			    					response["id"] = $(responses[i]).find('id')[1].textContent;
			    					response["date"] = $(responses[i]).find('date')[0].textContent;
			    					response["text"] = $(responses[i]).find('text')[0].textContent;
			    					var user = new Object();
			    					user["id"] = $(responses[i]).find('id')[0].textContent;
			    					user["email"] = $(responses[i]).find('email')[0].textContent;
			    					user["name"] = $(responses[i]).find('name')[0].textContent;
			    					user["locationName"] = $(responses[i]).find('locationName')[0].textContent;
			    					response["user"] = user;
			    					var itemDiv = $('<div></div>')
			    									.append(
			    											$('<font color="#404758">On ' + response.date + ' <br/>' + response.user.name + ' answered:</font>')
			    									)
			    									.append('<br/><br/>')
			    									.append(
			    											$('<font>' + response.text + '</font>')
			    												.css({ 'font-weight': 'bold' })
			    									);
			    					var li = $('<li></li>')
			    								.append(itemDiv);
			    					resultList.append(li);
			    				}
			    				div.append(resultList);
			    				resultList
			    					.css({'margin-left': '20px',
			    						  'margin-right': '20px',
			    						  'font-weight': 'bold'});
			    			}
			    		}
			});
			return div;
		},
		AddResponse: function(userId, questionId, text){
			$.mobile.showPageLoadingMsg();
			var url = GS.processorUrl + "/RequestProcessor.ashx?cmd=addResponse&userId="+userId+"&text="+escape(text)+"&questionId="+escape(questionId);
			$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			var xml = unescape(proxy_resp.content);
			    			var xmlDoc = $.parseXML(xml);
			    			var id = $(xmlDoc).find('id')[0].textContent;
	    					var response = new Object();
	    					response["id"] = id;
	    					response["date"] = (new Date()).toString();
	    					response["text"] = text;
	    					var user = new Object();
	    					user["id"] = GS.user.id;
	    					user["email"] = GS.user.email;
	    					user["name"] = GS.user.name;
	    					user["locationName"] = '';
	    					response["user"] = user;
	    					var itemDiv = $('<div></div>')
							.append(
									$('<font color="#404758">On ' + response.date + ' <br/>' + response.user.name + ' answered:</font>')
							)
							.append('<br/><br/>')
							.append(
									$('<font>' + response.text + '</font>')
										.css({ 'font-weight': 'bold' })
							);
							var li = $('<li></li>')
										.append(itemDiv);
							$("#responses-list" + questionId).append(li);
							$("#responses-list" + questionId).listview('refresh');
			    			$.mobile.hidePageLoadingMsg();
			    			alert("Your response was added successfully.");
			    			//GetQuestionScreen: function(question, tab)
			    		}
			});
		},
		AddQuestion: function(userId, text, appId, tab){
			$.mobile.showPageLoadingMsg();
			var url = GS.processorUrl + "/RequestProcessor.ashx?cmd=addQuestion&userId="+userId+"&text="+escape(text)+"&appId="+escape(appId);
			$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			var xml = unescape(proxy_resp.content);
			    			var xmlDoc = $.parseXML(xml);
			    			var id = $(xmlDoc).find('id')[0].textContent;
	    					var question = new Object();
	    					question["id"] = id;
	    					question["date"] = (new Date()).toString();
	    					question["text"] = text;
	    					question["responseTotal"] = 0;
	    					var user = new Object();
	    					user["id"] = GS.user.id;
	    					user["email"] = GS.user.email;
	    					user["name"] = GS.user.name;
	    					user["locationName"] = '';
	    					question["user"] = user;
	    					var number = parseInt(Math.random()*10000);
	    					$('#question-list-' + tab.tabId).append(Discussion.DrawQuestionItem(question, tab, number));
			    			$.mobile.hidePageLoadingMsg();
			    			alert("Your question was added successfully.");
			    		}
			});
		}
}