/**
 * Review
 */

var Review = {
		GetReviewsScreen: function(item, parentDiv, screenId){
			var div = $('<div></div')
						.attr('id', screenId +'-review-screen')
						.css({display:'none', top: '0px'})
						.addClass('child-screen');
			var reviewsListContainer = $('<div></div>').addClass('review-list');
			var addButton = $('<button data-role="button">Add review</button>')
						.addClass('btn-fix')
						.addClass('ui-btn')
						.addClass('ui-btn-corner-all')
						.addClass('ui-shadow')
						.addClass('ui-btn-up-d')
						.css({ width: '120px', 'font-size': '16px', 'height': '30px' })
						.data('txtId', screenId + '-review-txt')
						.data('screenId', screenId +'-review-screen')
						.data('item', item)
						.bind( "click", function(event, ui) {
							var reviewText = $("#" + $(this).data('txtId')).val();
							var type = "physical";
							if(item.headline !== undefined){
								type = "online";
							}
							Review.AddReview($(this).data('item'), type, reviewText, GS.user.id, '5', $(this).data('screenId'));
						});

			var textHeight = Math.min(150, GS.screenY/3);
			var reviewTxt = $('<textarea/>')
								.attr('id', screenId + '-review-txt')
								.css({ height: textHeight + 'px', width: (GS.screenX - 100) + 'px' })
								.addClass('ui-input-text') 
								.addClass('ui-body-null')
								.addClass('ui-corner-all') 
								.addClass('ui-shadow-inset') 
								.addClass('ui-body-c');
			
			var reviewFormContainer = $('<div></div>').css({ 'margin': '5px 10px' });
			reviewFormContainer
				.append(reviewTxt)
				.append(addButton);
			
			div.append(reviewsListContainer).append(reviewFormContainer);
			return div;
		},
		GetReviews: function(div, item){
			var type = "physical";
			if(item.headline !== undefined){
				type = "online";
			}
			var url = GS.processorUrl + "/RequestProcessor.ashx?cmd=getReviews&" +
							"&storeName=" + escape(item.title) +
							"&storeType=" + type;
							if(type == "online"){
								url += ("&storeUrl=" + item.url);
							}
							if(type == "physical"){
								url += ("&latitude=" + item.lat);
								url += ("&longitude=" + item.lng);
							}
			$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			var xml = unescape(proxy_resp.content);
		    				var xmlDoc = $.parseXML(xml);
		    				var reviewNodes = $(xmlDoc).find('review');
		    				var reviews = new Array();
		    				var ul = $('<ul data-role="listview" data-inset="true" data-theme="d"></ul>')
											.css({ 'margin': '0 0 0 0', 'padding': '0px' })
											.attr('id', $(div).attr('id') + '-review-list');
		    				for(var i=0; i<reviewNodes.length; i++){
		    					var review = new Object();
		    					review["userName"] = $(reviewNodes[i]).find('name')[0].textContent;
		    					review["userEmail"] = $(reviewNodes[i]).find('email')[0].textContent;
		    					review["text"] = $(reviewNodes[i]).find('text')[0].textContent;
		    					review["date"] = $(reviewNodes[i]).find('date')[0].textContent;
		    					review["rating"] = $(reviewNodes[i]).find('rating')[0].textContent;
		    					ul.append(Review.GetReviewItem(review));
		    					reviews.push(review);
		    				}
		    				div.find('.review-list').append(ul);
			    			//$("#"+screenId).find('textarea').val('');
			    			//alert("Your review was added successfully.");
			    		}
			});
		},
		GetReviewItem: function(review){
			var li = $('<li></li>')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.addClass('item-question')
						.css({width:'100%', 'border-collapse': 'collapse', cursor: 'pointer'});
			var itemDiv = $('<div></div>')
							.append(
								$('<font>' + review.userName + ' asked: </font>')
									.css({
										'font-size':'14px'
									})
							)
							.append('<br/><br/>')
							.append(
									$('<font>' +review.text + '</font>')
							)
							.css({ 'margin': '5px 5px 5px 20px' });
			li.append(itemDiv);
			return li;
		},
		AddReview: function(item, type, review, userId, rating, screenId){
			if(review.length == 0){
				alert("Your review is empty!");
				return;
			}
			var url = GS.processorUrl + "/RequestProcessor.ashx?cmd=addReview&" +
						"userId=" + userId +
						"&rating=" + rating +
						"&text=" + escape(review) +
						"&storeName=" + escape(item.title) +
						"&storeType=" + type;
						if(type == "online"){
							url += ("&storeUrl=" + item.url);
						}
						if(type == "physical"){
							url += ("&latitude=" + item.lat);
							url += ("&longitude=" + item.lng);
						}
			$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(url), 
		    		function (data, status){
			    		//alert("Status: " + status);
			    		if(status == 'success'){
			    			$("#"+screenId).find('textarea').val('');
			    			alert("Your review was added successfully.");
			    		}
			});
		}
}