/**
 * Favorites
 */

var Favorites = {
		type: 'Favorites',
		GetScreen: function(tab){
			try{
				var div=$('#'+tab.tabType+'-'+tab.tabId);
				div.empty();
				var rawFav = window.localStorage.getItem("snappii-favorites-" + appId);
				Log.WriteLog("Open Favorites: " + rawFav);
				var fav = eval("("+ rawFav +")");
				if(fav == null){
					return;
				}
				var listId = 'favorites-list-' + tab.tabId;
				var ul = $('<ul data-role="listview" data-inset="true" data-theme="d"></ul>')
							.attr('id', listId)
							.css({ 'margin': '0 0 0 -40px' });
				div.css({ height: (60 * fav.items.length) + 'px'})
				for(var i=0; i<fav.items.length; i++){
					var obj = fav.items[i];
					ul.append(Favorites.DrawFavoritesItem(obj, tab, i));
				}
				div.append(ul);
			}
			catch(err){
				alert("Favorites can not be read.");
				Log.WriteLog("Favorites error: " + err.message + "; " + err.description);
				Log.WriteLog(window.localStorage.getItem("snappii-favorites-" + appId));
				window.localStorage.setItem("snappii-favorites-" + appId, null)
			}
		},
		AddToFavorites: function(item){
			if(window.localStorage !== undefined){
				try{
					var rawFav = window.localStorage.getItem("snappii-favorites-" + appId);
					Log.WriteLog("Add to Favorites - current: " + rawFav);
					var fav = null;
					if(rawFav==null || rawFav=="" || rawFav===undefined || rawFav=="null"){
						fav = new Object();
						fav["items"] = new Array();
					}
					else{
						fav = eval("(" + rawFav + ")");
					}
					fav.items.push(item);
					var jsonString = "{ \"items\": [";
					for(var i = 0; i < fav.items.length; i++){
						jsonString += JSON.stringify(fav.items[i]);
						if(i != fav.items.length - 1){
							jsonString += ", ";
						}
					}
					jsonString+=" ]}";
					window.localStorage.removeItem("snappii-favorites-" + appId);
					window.localStorage.setItem("snappii-favorites-" + appId, jsonString);
					Log.WriteLog("Add Favorites: " + jsonString);
					alert('Item saved in your favorites list.');
				}
				catch(err){
					alert("Favorites can not be write.");
					Log.WriteLog("Add Favorites error: "  + err.message + "; " + err.description);
				}
			}
		},
		onOpen: function(tab){
			Favorites.GetScreen(tab);
		},
		DrawFavoritesItem: function(item, tab, number){
			var li = $('<li></li>')
						.data('item', item)
						.data('tabType', tab.tabType)
						.data('tabId', tab.tabId)
						.data('num', number)
						.data('itemId', tab.tabId+'-'+number)
						.attr('data-theme', 'c')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.css({width:'100%', 'border-collapse': 'collapse'})
						.append(
								$('<p>' + ((item.title !== undefined) ? item.title : item.headline) + '</p>')
									.css({ 'margin-left': '20px' })
						)
						.click(function(){
							 $("#favorites-screen-"+$(this).data('itemId')).find('ul').listview();
							 $("#favorites-screen-"+$(this).data('itemId')).css({display:'block'});
							 ScrollUp(tab.tabType+'-'+tab.tabId);
							 $("#" + $(this).data('tabType') + '-' + $(this).data('tabId')).css({height: '1000px'});
								GS.showBackBtn();
								GS.BackBtn
								//.unbind()
								.data('screenid', "favorites-screen-"+$(this).data('itemId'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								});
								return false;
						});
			
			var screen = $('<div></div>')
							.attr('id', 'favorites-screen-' + tab.tabId + '-' + number)
							.css({display:'none', top: '0'})
							.addClass('child-screen');
			var div = $("#"+ tab.tabType+'-'+tab.tabId);
			if(item.title === undefined){
				//for physical objects
				var url = item.url;
				if(url.indexOf('http')<0){
					url = 'http://' + url;
				}
				
				var width = '100%'; //(GS.screenX - 40)+'px'
				var header = $('<h3>'+item.headline+'</h3>')
							.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'width':width});
				var twitterLink = "http://twitter.com/home?status=" + escape(item.headline + "; " + url);
				var actionList = $('<ul data-role="listview" data-inset="true" data-theme="d">'+
									'<li><a href="'+ url+ '">Check site</a></li>'+
									'<li><a href="#">Reviews</a></li>'+
									//'<li><a href="#">Add to Favorites</a></li>'+
									'<li><a href="' + twitterLink + '">Add to Twitter</a></li>'+
									'<li><a href="http://facebook.com">Add to Facebook</a></li>'+
								 '</ul>');
				
				var descriptionArea = $('<div></div>')
											.css({margin:'10px'})
											.append(
													$('<label>' + item.headline + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											)
											.append('<br/>')
											.append(
													$('<label>' + item.description + '</label>')
														.css({ color:'#F0F0F0', 'font-size':'16px' })
											);
				var description = $('<p>' + item.description + '</p>')
									.css({'font-size':'12px', 'margin-left': '10px', 'margin-bottom': '5px', 'margin-top': '5px', 'font-weight':'normal', 'width':width});
				var arrow = $('<span class="ui-icon ui-icon-arrow-r"></span>').css({right: '30px'});
				screen.append(descriptionArea).append(actionList);	
				div.append(screen);
			}
			else{
				var address = '';
				if(item.addressLines !== undefined){
					for(var i=0; i<item.addressLines.length;i++){
						address += (item.addressLines[i] + ' ');
					}
				}
				var descriptionArea = $('<div></div>')
										.css({margin:'10px'})
										.append(
												$('<label>' + item.title + '</label>')
													.css({ color:'#F0F0F0', 'font-size':'16px' })
										)
										.append('<br/>')
										.append(
												$('<label>' + address + '</label>')
													.css({ color:'#F0F0F0', 'font-size':'16px' })
										);
				var mapScreen = $('<div></div>')
									.attr('id', 'favorites-map-screen-' + tab.tabId+'-'+number)
									.css({display:'none', top: '0'})
									.addClass('child-screen')
									.append(
										$('<iframe src="' + GS.mapPageUrl + '" style="width:100%; height:' + GS.screenY + 'px"></iframe>')
									);
				var twitterLink = "http://twitter.com/home?status=" + escape(item.title + "; " + address);
				var actionList = $('<ul data-role="listview" data-inset="true" data-theme="d">'+
									'<li><a href="tel:' + ((item.phoneNumbers === undefined) ? '' : item.phoneNumbers[0].number) + '">Call</a></li>'+
									//'<li><a href="'+item.ddUrl+ '" target="_blank">Map and Direction</a></li>'+
									'<li><a href="tel:' + ((item.phoneNumbers === undefined) ? '' : item.phoneNumbers[0].number) + '">Send SMS</a></li>'+
									'<li><a href="#">Send Email</a></li>'+
									'<li><a href="mailto:'+'">Reviews</a></li>'+
									'<li><a href="#">Add to Contacts</a></li>'+
									//'<li><a href="#">Add to Favorites</a></li>'+
									'<li><a href="' + twitterLink + '">Add to Twitter</a></li>'+
									'<li><a href="http://facebook.com">Add to Facebook</a></li>'+
								 '</ul>');
				actionList.append(
						$('<li><a href="#">Map and Direction</a></li>')
							.data('item', item)
							.data('map-screen','favorites-map-screen-' + tab.tabId+'-'+number)
							.click(function(){
								//Favorites.AddToFavorites($(this).data('item'));
								window.localStorage.setItem("map-center", GS.location.latitude+","+GS.location.longitude);
								window.localStorage.setItem("map-latitude", GS.location.latitude);
								window.localStorage.setItem("map-longitude", GS.location.longitude);
								window.localStorage.setItem("map-height", GS.screenY - 250);
				    			var markersJson = "{ 'markers': [" + JSON.stringify($(this).data('item')) + "]}";
				    			window.localStorage.setItem("map-markers", markersJson);
				    			$("#" + $(this).data("map-screen")).find('iframe')[0].contentDocument.location.reload(true);
								$(".child-screen").css({ display: 'none' });
								$("#" + $(this).data("map-screen")).css({ display: 'block' });
								return false;
							})
				);
				screen.append(descriptionArea).append(actionList);	
				div.append(screen).append(mapScreen);
			}
			return li;
		}
}