/**
 * List tab
 */

var List = {
				type: 'List',
				GetScreen:function(tab){
					Log.WriteLog("Get List Screen started: id = " + tab.tabId);
					var div= $("#"+ tab.tabType+'-'+tab.tabId);
					var listId = tab.control.listId;
					var url = GS.processorUrl + '/RequestProcessor.ashx?cmd=getListData&listId='+escape(listId)
								+ '&appDbId='+appId;
					if(window.Ext !== undefined){
						if(window.device.version.indexOf("2.2") < 0){
							url = window.Ext.GetListDataUrl(GS.processorUrl, listId, appId);
						}
					}
					$.getScript(GS.snappiiProxyTool + "&url=" + escape(url), 
				    		function (data, status){
								Log.WriteLog("Get List Data: status = " + status);
								var rawjson = proxy_resp.content;
								if(window.Ext !== undefined){
									if(window.device.version.indexOf("2.2") < 0){
										rawjson = window.Ext.Decrypt(unescape(unescape(rawjson)));
									}
								}
								var xmlList = $(unescape(rawjson));
								//Log.WriteLog("XML: " + xmlList[0].innerHTML);
								var items = xmlList.find('item');
								Log.WriteLog("Get " + items.length + " items");
								$('#list-' + tab.tabId).remove();
								var ul = $('<ul data-role="listview" class="ui-listview" id="list-' + tab.tabId + '"></ul>');
				    			ul.addClass('rss-ul').css({'margin':'0px'});
								for(var i=0; i<items.length; i++){
									var item = items[i];
									//Log.WriteLog("Get item for item #" + i + "; itemHTML = " + item.outerHTML);
									try{
										ul.append(List.DrawListItem(tab, item, i));
									}
									catch(Error){
										Log.WriteLog("Error on item #" + i + " Line: " + Error.lineNo + ", Message: " + Error.message +", Source: " + Error.source);
									}
								}
								div.append(ul);
								//Log.WriteLog("Div height: " + div.css('height') + "; Ul height: " + ul.css('height'));
					});
				},
				DrawListItem: function(tab, item, number){
					$('#list-item-' + tab.tabId + '-' + number).remove();
					$('#list-screen-' + tab.tabId + '-' + number).remove();
					var li = $('<li></li>')
						.attr('data-theme', 'c')
						.addClass('ui-btn')
						.addClass('ui-li')
						.addClass('ui-btn-icon-right')
						.addClass('ui-btn-up-c')
						.css({width:'100%', 'font-size': '14px', 'padding': '0px'})//.css({width:GS.screenX+'px'})
						.data('screenid', 'list-screen-' + tab.tabId+'-'+number)
						.data('item', item)
						.data('tab', tab)
						.click(function(){
							 	$("#"+$(this).data('screenid')).css({display:'block'});
							 	$("#"+ $(this).data('tab').tabType+'-'+$(this).data('tab').tabId).css({height: GS.screenY + 'px'})
							 	$("#list-" + $(this).data('tab').tabId).css({display: 'none'});
							 	Log.AddActivity({ name: 'ViewListControlItem', params: [ { paramName: 'item', paramValue: number } ] });
								GS.showBackBtn();
								BackStack.down({ screenId: $(this).data("screenid") });
								/*GS.BackBtn
								//.unbind()
								.data('screenid', $(this).data('screenid'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								});*/
						});
					var itemDiv = $('<div></div>')
									.attr('id', 'list-item-' + tab.tabId + '-' + number)
									.data('screenid', 'list-screen-' + tab.tabId+'-'+number)
									.css({
										width:'100%',
										position:'relative',
										height: tab.control.listCellView.maxHeight + 'px',
										overflow:'hidden',
										'padding': '2px'
									});
					var screen = $('<div></div>')
									.attr('id', 'list-screen-' + tab.tabId+'-'+number)
									.css({display:'none', top: '0px', 'background-color':'#F0F0F0'})
									.addClass('child-screen');
					$("#"+ tab.tabType+'-'+tab.tabId).append(screen);
					var maxY = 0;
					for(var i=0; i<tab.control.listCellView.cellControls.length; i++){
						var cellControl = tab.control.listCellView.cellControls[i];
						var type = cellControl.controlType;
						var controlHTML = '';
						if(type == 'Label'){
							var tag = cellControl.text.substring(1, cellControl.text.length-1);
							var node = $(item).find(tag)[0].childNodes[0];
							Log.WriteLog("Node count: " + $(item).find(tag)[0].childNodes.length + "; Tag: " + tag);
							var fieldsList = "";
							for (var index in node){
								fieldsList += (index + "; ");
							}
							//Log.WriteLog("Node Fields: " + fieldsList);
							var text = "";
							if(node.textContent !== undefined){
								text = List.removeCDATA(node.textContent);
							}
							else{
								text = List.removeCDATA(node.data);
							}
							
							controlHTML = $('<label></label>')
											.text(text)
											.css({
												position:'absolute',
												top: cellControl.frame.top + 'px',
												left: cellControl.frame.left + 'px',
												width: cellControl.frame.width + 'px',
												height: cellControl.frame.height + 'px',
												'font-size': cellControl.fontSize + 'px',
												color: 'rgb('+cellControl.color.red+','+cellControl.color.green+','+cellControl.color.blue+')',
												overflow: 'hidden'
											});
						}
						if(type == 'Image'){
							var url = List.removeCDATA($(item).find(cellControl.url.substring(1, cellControl.url.length-1))[0].childNodes[0].textContent);
							controlHTML = $('<img></img>')
											.attr('src', url)
											.css({
												position:'absolute',
												top: cellControl.frame.top + 'px',
												left: cellControl.frame.left + 'px',
												width: cellControl.frame.width + 'px',
												height: cellControl.frame.height + 'px'
											});
						}
						itemDiv.append(controlHTML);
					}
					for(var i=0; i<tab.control.listDetailView.pageControls.length; i++){
						var pageControl = tab.control.listDetailView.pageControls[i];
						var type = pageControl.controlType;
						var controlHTML = '';
						if(type == 'Label'){
							var text = List.removeCDATA($(item).find(pageControl.text.substring(1, pageControl.text.length-1))[0].childNodes[0].textContent);
							var strings = text.split('\n');
							if(strings.length > 1){
							//if(window.device !== undefined){
								text = '';
								/*for(var j=0; j < $(item).find(pageControl.text.substring(1, pageControl.text.length-1))[0].childNodes.length; j++){
									if($(item).find(pageControl.text.substring(1, pageControl.text.length-1))[0].childNodes[j].nodeName == '#text'){
										text += ('<br/>' + $(item).find(pageControl.text.substring(1, pageControl.text.length-1))[0].childNodes[j].textContent);
									}
								}*/
								for(var j = 0; j < strings.length; j++){
									text += strings[j];
									if(j != strings.length - 1){
										text += '<br/>';
									}
								}
							//}
							}
							
							controlHTML = $('<div></div>')
											.append(text)
											.css({
												position:'absolute',
												top: pageControl.frame.top + 'px',
												left: pageControl.frame.left + 'px',
												width: pageControl.frame.width + 'px',
												height: 'auto',
												//height: pageControl.frame.height + 'px',
												'font-size': pageControl.fontSize + 'px',
												color: 'rgb('+pageControl.color.red+','+pageControl.color.green+','+pageControl.color.blue+')',
												overflow: 'hidden'
											});
						}
						if(type == 'Image'){
							var url = List.removeCDATA($(item).find(pageControl.url.substring(1, pageControl.url.length-1))[0].childNodes[0].textContent);
							controlHTML = $('<img></img>')
											.attr('src', url)
											.css({
												position:'absolute',
												top: pageControl.frame.top + 'px',
												left: pageControl.frame.left + 'px',
												width: pageControl.frame.width + 'px',
												height: pageControl.frame.height + 'px'
											});
						}
						if(pageControl.frame.top + pageControl.frame.height > maxY){
							maxY = pageControl.frame.top + pageControl.frame.height;
						}
						screen.append(controlHTML);
					}
					screen.css({height: '1500px'});
					screen.parent().css({height: '1500px'});
					//screen.parent().hide();
					
					//$("#"+ tab.tabType+'-'+tab.tabId).append(itemDiv);
					li.append(itemDiv);
					return li;
				},
				removeCDATA: function(str){
					return str
							.replace("<![CDATA[", "")
							.replace("]]>", "")
							.replace("[CDATA[", "")
							.replace("]]", "");
					/*if(str.indexOf("<![CDATA[") == 0){
						return str.substring(7, str.length-2);
					}
					return str;*/
				},
				onOpen: function(tab){
					$("#list-" + tab.tabId).css({display: 'block'});
					$("#" + tab.tabType + "-" + tab.tabId).find(".child-screen").css({display: 'none'});
				}
			}
		