/**
 * Login button
 */

var LoginButton = {
		type: 'LoginButton',
		drawControl: function(control, tab){
			var tabDiv = $("#"+tab.tabType+"-"+tab.tabId);
			$("#login-screen-"+tab.tabId).remove();
			var screen = $('<div></div>')
							.attr('id', 'login-screen-'+tab.tabId)
							.css({display:'none'})
							.addClass('child-screen');
			var lblText = $('<p>Login to participate in discussions and to write reviews</p>');
			var curLogin = "";
			var curPassword = "";
			if(window.localStorage !== undefined){
				curLogin = window.localStorage.getItem("snappii-login");
				curPassword = window.localStorage.getItem("snappii-password");
				if (curLogin == null) { curLogin = ""};
				if (curPassword == null) { curPassword = ""};
			}
			var txtEmail = $('<div data-role="fieldcontain">'+
							    '<label for="txtEmail-' + tab.tabId + '">Email Address:</label>'+
							    '<input type="text" name="name" id="txtEmail-' + tab.tabId + '" value="' + curLogin + '" class="form-input" />'+
							'</div>');
			var txtPassword = $('<div data-role="fieldcontain">'+
							    '<label for="txtPassword-' + tab.tabId + '">Password:</label>'+
							    '<input type="password" name="name" id="txtPassword-' + tab.tabId + '" value="' + curPassword + '" class="form-input" />'+
								'</div>');

			var btnLogin = $('<a href="#" data-role="button" data-inline="true">Login</a>')
							.css({ width: '120px', height: '30px' })
							.data('id', tab.tabId)
							.click(function(){
								var id = $(this).data('id');
								var txtEmail = $("#txtEmail-" + id).val();
								var txtPass = $("#txtPassword-" + id).val();
								var loginUrl = GS.processorUrl + "/RequestProcessor.ashx?cmd=login&email=" 
												+ escape(txtEmail) + "&password=" + escape(txtPass);
								if(window.Ext !== undefined){
									loginUrl = window.Ext.GetLoginUrl(GS.processorUrl, txtEmail, txtPass)
								}
								$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(loginUrl), 
							    		function (data, status){
								    		//alert("Status: " + status);
								    		if(status == 'success'){
								    			var xml = unescape(proxy_resp.content);
								    			if(xml == 'Web error'){
								    				var message = 'Email address and password do not match.';
								    				alert(message);
								    			}
								    			else{
									    			if(window.Ext !== undefined){
									    				xml = window.Ext.Decrypt(unescape(xml));
									    			}
								    				var xmlDocL = $.parseXML(xml);
									    			var id = $(xmlDocL).find('id')[0].textContent;
									    			var email = $(xmlDocL).find('email')[0].textContent;
									    			var name = $(xmlDocL).find('name')[0].textContent;
									    			GS.user = { 'name': name, 'id':id, 'email': email};
									    			alert("You logged successfully.");
									    			GS.BackBtn.trigger('click');
								    			}
								    			proxy_resp = null;
								    		}
							    		});
								return false;
							});
			var btnForgot = $('<div data-role="fieldcontain">'+
							    '<label for="txtPassword">Forgot your password?</label>'+
								'</div>')
								.append(
										$('<a href="#" data-role="button" data-inline="true">Email my password</a>')
										.data('id', tab.tabId)
										.css({ width: '180px', height: '30px' })
										.click(function(){
											var id = $(this).data('id');
											var txtEmail = $("#txtEmail-" + id).val();
											var forgotUrl = GS.processorUrl + "/RequestProcessor.ashx?cmd=forgotPassword&email=" + txtEmail;
											$.getScript(GS.snappiiUrl + "/proxy.ashx?convert=json&url=" + escape(forgotUrl), 
										    		function (data, status){
											    		//alert("Status: " + status);
											    		if(status == 'success'){
											    			var xml = unescape(proxy_resp.content);
											    			if(xml == 'Web error'){
											    				var message = 'There are no registered user with this email.';
											    				alert(message);
											    			}
											    			else{
											    				var xmlDocL = $.parseXML(xml);
											    				if($(xmlDocL).find('result')[0].textContent == 'Success'){
											    					alert("The email with your password has been sent.");
											    				}
											    			}
											    		}
											});
											return false;
										})
								);
			var btnSign = $('<div data-role="fieldcontain">'+
						    '<label for="txtPassword">Not registered yet?</label>'+
							'</div>')
							.append(
									$('<a href="#" data-role="button" data-inline="true" style="width:120px; height:30px">Sign up now</a>')
										.data('tabId', tab.tabId)
										.click(function(){
											$("#signup-screen-" + $(this).data('tabId')).css({ display: 'block' });
											$("#login-screen-" + $(this).data('tabId')).css({ display: 'none' });
										})
							);
			var form = $('<div></div>').css('margin', '10px');
			form
				.append(lblText)
				.append(txtEmail)
				.append(txtPassword)
				.append(btnLogin)
				.append(btnForgot)
				.append(btnSign);
			screen.append(form);
			var ctrlDiv = $("<a></a>")
							.append(
									$('<img src="' + control.imageUrl + '" />')
											.css({width: control.frame.width+'px', 
												  height: control.frame.height+'px'})
							)
							//.attr("data-role", "button")
							.data('tab', tab)
							.data('id', tab.tabId)
							.addClass('control-button')
							.data('control', control)
							.css({width: control.frame.width+'px', 
								height: control.frame.height+'px',
								position: 'absolute',
								top: control.frame.top+'px',
								left: control.frame.left+'px',
								margin: '0px',
								'font-size': GS.standardFontSize + 'px'
							})
							.click(function(){
								ScrollUp("login-screen-"+$(this).data('id'));
								ScrollUp($(this).data('tab').tabType+'-'+$(this).data('tab').tabId);
								$("#login-screen-"+$(this).data('id')).css({'display':'block'});
								GS.showBackBtn();
								BackStack.down({ screenId: "login-screen-"+$(this).data('id') });
								/*GS.BackBtn
								//.unbind()
								.data('screenid', "login-screen-"+$(this).data('id'))
								.click(function(){
									$("#"+$(this).data('screenid')).css({display:'none'});
									GS.hideBackBtn();
								})*/
								return false;
							});
			tabDiv.append(ctrlDiv);
			tabDiv.append(screen);
		}
}