/**
 * Search methods
 */

google.load('search', '1');
var localSearch = null;

var search = {
    local: function(category, query, location, callback, screen, tab, showNoResultMessage) {
        var self = this;
        var result = new Array();
        var page = 0;
        localSearch = new google.search.LocalSearch();
        localSearch.setCenterPoint(location);
        localSearch.setSearchCompleteCallback(this, handle, null);
        localSearch.setResultSetSize(google.search.Search.LARGE_RESULTSET);

        // $('#result').empty();
        //localSearch.execute('"' + category + ' ' + query + '" "' + query + '"');
        localSearch.execute(query);

        function handle() {
            if (localSearch.results && localSearch.results.length > 0) {
                $.each(localSearch.results, function(index, value) {
                    var current = new Object();
                    current.title = value.titleNoFormatting;
                    if (value.phoneNumbers != undefined)
                        current.number = value.phoneNumbers[0].number;
                    else
                        current.number = '';

                    current.street = value.streetAddress;
                    current.city = value.city;
                    current.region = value.region;
                    current.mapUrl = value.staticMapUrl;
                    result.push(current);
                });

                if (localSearch.cursor !== undefined && localSearch.cursor != null) {
                    if (localSearch.cursor.pages[page + 1] == undefined) {
                        callback(result, screen, tab);
                    }
                    else
                        localSearch.gotoPage(++page);
                }
                else {
                    callback(result, screen, tab);
                }

            }
            else {
            	callback([], screen, tab, showNoResultMessage);
            	$.mobile.hidePageLoadingMsg();
            	$($("#content-body").children()[0]).css({height: GS.screenY + 'px'});
            }

        }



    },

    imageSearch: function(query, callback) {
        var self = this;
        var result = new Array();
        var page = 0;
        var imageSearcher = new google.search.ImageSearch();
        imageSearcher.setSearchCompleteCallback(this, handle);
        imageSearcher.setResultSetSize(8);
        imageSearcher.execute(query);

        function handle() {
            if (imageSearcher.results && imageSearcher.results.length > 0) {
                $.each(imageSearcher.results, function(index, value) {
                    result.push(value);
                });

                if (imageSearcher.cursor !== undefined && imageSearcher.cursor != null) {
                    if (imageSearcher.cursor.pages[page + 1] == undefined) {
                        callback(result);
                    }
                    else {
                        page++;
                        imageSearcher.gotoPage(page);
                    }
                }
                else {
                    callback(result);
                }

            }

        }
    }
};